import db_postgres, macros, options, postgres, sequtils, strutils, times,
  timeutils, unicode, uuids

import ./models
import ./db_common

type
  PMApiDb* = ref object
    conn: DbConn

  
proc connect*(connString: string): PMApiDb =
  result = PMApiDb(conn: open("", "", "", connString))

macro makeGetRecord(modelType: type): untyped =
  echo modelType.getType.treeRepr
#[
  let procIdent = ident("get" & $modelType.getType[1])
  return quote do:
    proc `procIdent`*(db: PMApiDb, id: UUID): `modelType` = return db.conn.getRecord(`modelType`, id)
]#

proc createUser*(db: PMApiDb, user: User): User = return db.conn.createRecord(user)
proc createApiToken*(db: PMApiDb, token: ApiToken): ApiToken = return db.conn.createRecord(token)
proc createMeasure*(db: PMApiDb, measure: Measure): Measure = return db.conn.createRecord(measure)
proc createValue*(db: PMApiDb, value: Value): Value = return db.conn.createRecord(value)

proc getUser*(db: PMApiDb, id: UUID): User = return db.conn.getRecord(User, id)
proc getUser*(db: PMApiDb, id: string): User = return db.conn.getRecord(User, parseUUID(id))
proc getApiToken*(db: PMApiDb, id: UUID): ApiToken = return db.conn.getRecord(ApiToken, id)
proc getMeasure*(db: PMApiDb, id: UUID): Measure = return db.conn.getRecord(Measure, id)
proc getValue*(db: PMApiDb, id: UUID): Value = return db.conn.getRecord(Value, id)

#proc getUsersWhere*(db: PMApiDb, whereClause: string, values: varargs[string, dbFormat]): User =
#  return db.conn.getRecordsWhere(User, whereClause, values)
